<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 10</a>

    <script>
        class Node {
            constructor(data) {
                this.data = data;
                this.left = null;
                this.right = null;
                this.nextRight = null;
            }
        }

        function subArbol (root1, root2) {
            if (root1 === null && root2 === null)
                return true;
                
            if (root1 == null || root2 === null)
                return false;


            return (root1.data === root2.data 
                    && subArbol(root1.left, root2.left) 
                    && subArbol(root1.right, root2.right));
        }

        function esUnSubAbol (T, S) {
            if (S === null)
                return true;

            if (T === null)
                return false;

            if (subArbol(T,S))
                return true;

            return esUnSubAbol(T.left, S) || esUnSubAbol(T.right, S);
        }

        let root1,
            root2;
        
        root1 = new Node(26);
        root1.right = new Node(3);
        root1.right.right = new Node(3);
        root1.left = new Node(10);
        root1.left.left = new Node(4);
        root1.left.left.right = new Node(30);
        root1.left.right = new Node(6);

        root2 = new Node(10);
        root2.right = new Node(6);
        root2.left = new Node(4);
        root2.left.right = new Node(30);

        if (esUnSubAbol(root1,root2)) 
            console.log("El Arbol 2 es un sub-arbol del Arbol 1");
        else
            console.log("El Arbol 2 NO un sub-arbol del Arbol 1");

    </script>
    
</body>
</html>